//
// DmasAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class DmasAPI {
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdDaysDateGet: String { 
        case timestampinit = "timestampInit"
        case airqualityindex = "airQualityIndex"
        case particulatematter1min = "particulateMatter1Min"
        case particulatematter1avg = "particulateMatter1Avg"
        case particulatematter1max = "particulateMatter1Max"
        case particulatematter2p5min = "particulateMatter2p5Min"
        case particulatematter2p5avg = "particulateMatter2p5Avg"
        case particulatematter2p5max = "particulateMatter2p5Max"
        case particulatematter10min = "particulateMatter10Min"
        case particulatematter10avg = "particulateMatter10Avg"
        case particulatematter10max = "particulateMatter10Max"
        case carbonmonoxidemin = "carbonMonoxideMin"
        case carbonmonoxideavg = "carbonMonoxideAvg"
        case carbonmonoxidemax = "carbonMonoxideMax"
        case nitrogendioxidemin = "nitrogenDioxideMin"
        case nitrogendioxideavg = "nitrogenDioxideAvg"
        case nitrogendioxidemax = "nitrogenDioxideMax"
        case sulfurdioxidemin = "sulfurDioxideMin"
        case sulfurdioxideavg = "sulfurDioxideAvg"
        case sulfurdioxidemax = "sulfurDioxideMax"
        case ozonemin = "ozoneMin"
        case ozoneavg = "ozoneAvg"
        case ozonemax = "ozoneMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdDaysDateGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A day of ECMWF Air Quality Forecast data for a DMA.

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdDaysDateGet(dmaId: Int, date: Date, fields: [String], unitScale: UnitScale_dmasDmaIdDaysDateGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastDmaDayObj?,_ error: Error?) -> Void)) {
        dmasDmaIdDaysDateGetWithRequestBuilder(dmaId: dmaId, date: date, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A day of ECMWF Air Quality Forecast data for a DMA.
     - GET /dmas/{dmaId}/days/{date}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "forecast" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "airQualityIndex" : "US EPA Air Quality Index",
      "particulateMatter1Min" : "Micrograms per cubic meter",
      "particulateMatter1Avg" : "Micrograms per cubic meter",
      "particulateMatter1Max" : "Micrograms per cubic meter",
      "particulateMatter2p5Min" : "Micrograms per cubic meter",
      "particulateMatter2p5Avg" : "Micrograms per cubic meter",
      "particulateMatter2p5Max" : "Micrograms per cubic meter",
      "particulateMatter10Min" : "Micrograms per cubic meter",
      "particulateMatter10Avg" : "Micrograms per cubic meter",
      "particulateMatter10Max" : "Micrograms per cubic meter",
      "carbonMonoxideMin" : "Parts per million",
      "carbonMonoxideAvg" : "Parts per million",
      "carbonMonoxideMax" : "Parts per million",
      "nitrogenDioxideMin" : "Parts per billion",
      "nitrogenDioxideAvg" : "Parts per billion",
      "nitrogenDioxideMax" : "Parts per billion",
      "sulfurDioxideMin" : "Parts per billion",
      "sulfurDioxideAvg" : "Parts per billion",
      "sulfurDioxideMax" : "Parts per billion",
      "ozoneMin" : "Parts per million",
      "ozoneAvg" : "Parts per million",
      "ozoneMax" : "Parts per million"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastDmaDayObj> 
     */
    open class func dmasDmaIdDaysDateGetWithRequestBuilder(dmaId: Int, date: Date, fields: [String], unitScale: UnitScale_dmasDmaIdDaysDateGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastDmaDayObj> {
        var path = "/dmas/{dmaId}/days/{date}"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let datePreEscape = "\(date)"
        let datePostEscape = datePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{date}", with: datePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastDmaDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdDaysDateStartdateEndGet: String { 
        case timestampinit = "timestampInit"
        case airqualityindex = "airQualityIndex"
        case particulatematter1min = "particulateMatter1Min"
        case particulatematter1avg = "particulateMatter1Avg"
        case particulatematter1max = "particulateMatter1Max"
        case particulatematter2p5min = "particulateMatter2p5Min"
        case particulatematter2p5avg = "particulateMatter2p5Avg"
        case particulatematter2p5max = "particulateMatter2p5Max"
        case particulatematter10min = "particulateMatter10Min"
        case particulatematter10avg = "particulateMatter10Avg"
        case particulatematter10max = "particulateMatter10Max"
        case carbonmonoxidemin = "carbonMonoxideMin"
        case carbonmonoxideavg = "carbonMonoxideAvg"
        case carbonmonoxidemax = "carbonMonoxideMax"
        case nitrogendioxidemin = "nitrogenDioxideMin"
        case nitrogendioxideavg = "nitrogenDioxideAvg"
        case nitrogendioxidemax = "nitrogenDioxideMax"
        case sulfurdioxidemin = "sulfurDioxideMin"
        case sulfurdioxideavg = "sulfurDioxideAvg"
        case sulfurdioxidemax = "sulfurDioxideMax"
        case ozonemin = "ozoneMin"
        case ozoneavg = "ozoneAvg"
        case ozonemax = "ozoneMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdDaysDateStartdateEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of daily ECMWF Air Quality Forecast data for a DMA.

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdDaysDateStartdateEndGet(dmaId: Int, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_dmasDmaIdDaysDateStartdateEndGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastDmaDayObj?,_ error: Error?) -> Void)) {
        dmasDmaIdDaysDateStartdateEndGetWithRequestBuilder(dmaId: dmaId, dateStart: dateStart, dateEnd: dateEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of daily ECMWF Air Quality Forecast data for a DMA.
     - GET /dmas/{dmaId}/days/{dateStart},{dateEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "forecast" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "airQualityIndex" : "US EPA Air Quality Index",
      "particulateMatter1Min" : "Micrograms per cubic meter",
      "particulateMatter1Avg" : "Micrograms per cubic meter",
      "particulateMatter1Max" : "Micrograms per cubic meter",
      "particulateMatter2p5Min" : "Micrograms per cubic meter",
      "particulateMatter2p5Avg" : "Micrograms per cubic meter",
      "particulateMatter2p5Max" : "Micrograms per cubic meter",
      "particulateMatter10Min" : "Micrograms per cubic meter",
      "particulateMatter10Avg" : "Micrograms per cubic meter",
      "particulateMatter10Max" : "Micrograms per cubic meter",
      "carbonMonoxideMin" : "Parts per million",
      "carbonMonoxideAvg" : "Parts per million",
      "carbonMonoxideMax" : "Parts per million",
      "nitrogenDioxideMin" : "Parts per billion",
      "nitrogenDioxideAvg" : "Parts per billion",
      "nitrogenDioxideMax" : "Parts per billion",
      "sulfurDioxideMin" : "Parts per billion",
      "sulfurDioxideAvg" : "Parts per billion",
      "sulfurDioxideMax" : "Parts per billion",
      "ozoneMin" : "Parts per million",
      "ozoneAvg" : "Parts per million",
      "ozoneMax" : "Parts per million"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastDmaDayObj> 
     */
    open class func dmasDmaIdDaysDateStartdateEndGetWithRequestBuilder(dmaId: Int, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_dmasDmaIdDaysDateStartdateEndGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastDmaDayObj> {
        var path = "/dmas/{dmaId}/days/{dateStart},{dateEnd}"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let dateStartPreEscape = "\(dateStart)"
        let dateStartPostEscape = dateStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateStart}", with: dateStartPostEscape, options: .literal, range: nil)
        let dateEndPreEscape = "\(dateEnd)"
        let dateEndPostEscape = dateEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateEnd}", with: dateEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastDmaDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdDaysGet: String { 
        case timestampinit = "timestampInit"
        case airqualityindex = "airQualityIndex"
        case particulatematter1min = "particulateMatter1Min"
        case particulatematter1avg = "particulateMatter1Avg"
        case particulatematter1max = "particulateMatter1Max"
        case particulatematter2p5min = "particulateMatter2p5Min"
        case particulatematter2p5avg = "particulateMatter2p5Avg"
        case particulatematter2p5max = "particulateMatter2p5Max"
        case particulatematter10min = "particulateMatter10Min"
        case particulatematter10avg = "particulateMatter10Avg"
        case particulatematter10max = "particulateMatter10Max"
        case carbonmonoxidemin = "carbonMonoxideMin"
        case carbonmonoxideavg = "carbonMonoxideAvg"
        case carbonmonoxidemax = "carbonMonoxideMax"
        case nitrogendioxidemin = "nitrogenDioxideMin"
        case nitrogendioxideavg = "nitrogenDioxideAvg"
        case nitrogendioxidemax = "nitrogenDioxideMax"
        case sulfurdioxidemin = "sulfurDioxideMin"
        case sulfurdioxideavg = "sulfurDioxideAvg"
        case sulfurdioxidemax = "sulfurDioxideMax"
        case ozonemin = "ozoneMin"
        case ozoneavg = "ozoneAvg"
        case ozonemax = "ozoneMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdDaysGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete daily ECMWF Air Quality Forecast for a DMA.

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdDaysGet(dmaId: Int, fields: [String], unitScale: UnitScale_dmasDmaIdDaysGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastDmaDayObj?,_ error: Error?) -> Void)) {
        dmasDmaIdDaysGetWithRequestBuilder(dmaId: dmaId, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete daily ECMWF Air Quality Forecast for a DMA.
     - GET /dmas/{dmaId}/days

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "forecast" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "airQualityIndex" : "US EPA Air Quality Index",
      "particulateMatter1Min" : "Micrograms per cubic meter",
      "particulateMatter1Avg" : "Micrograms per cubic meter",
      "particulateMatter1Max" : "Micrograms per cubic meter",
      "particulateMatter2p5Min" : "Micrograms per cubic meter",
      "particulateMatter2p5Avg" : "Micrograms per cubic meter",
      "particulateMatter2p5Max" : "Micrograms per cubic meter",
      "particulateMatter10Min" : "Micrograms per cubic meter",
      "particulateMatter10Avg" : "Micrograms per cubic meter",
      "particulateMatter10Max" : "Micrograms per cubic meter",
      "carbonMonoxideMin" : "Parts per million",
      "carbonMonoxideAvg" : "Parts per million",
      "carbonMonoxideMax" : "Parts per million",
      "nitrogenDioxideMin" : "Parts per billion",
      "nitrogenDioxideAvg" : "Parts per billion",
      "nitrogenDioxideMax" : "Parts per billion",
      "sulfurDioxideMin" : "Parts per billion",
      "sulfurDioxideAvg" : "Parts per billion",
      "sulfurDioxideMax" : "Parts per billion",
      "ozoneMin" : "Parts per million",
      "ozoneAvg" : "Parts per million",
      "ozoneMax" : "Parts per million"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastDmaDayObj> 
     */
    open class func dmasDmaIdDaysGetWithRequestBuilder(dmaId: Int, fields: [String], unitScale: UnitScale_dmasDmaIdDaysGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastDmaDayObj> {
        var path = "/dmas/{dmaId}/days"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastDmaDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdHoursGet: String { 
        case timestampinit = "timestampInit"
        case particulatematter1 = "particulateMatter1"
        case particulatematter2p5 = "particulateMatter2p5"
        case particulatematter10 = "particulateMatter10"
        case carbonmonoxide = "carbonMonoxide"
        case nitrogendioxide = "nitrogenDioxide"
        case sulfurdioxide = "sulfurDioxide"
        case ozone = "ozone"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdHoursGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete hourly ECMWF Air Quality Forecast for a DMA

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdHoursGet(dmaId: Int, fields: [String], unitScale: UnitScale_dmasDmaIdHoursGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastDmaHourObj?,_ error: Error?) -> Void)) {
        dmasDmaIdHoursGetWithRequestBuilder(dmaId: dmaId, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete hourly ECMWF Air Quality Forecast for a DMA
     - GET /dmas/{dmaId}/hours

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "forecast" : [ {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "particulateMatter1" : "Micrograms per cubic meter",
      "particulateMatter2p5" : "Micrograms per cubic meter",
      "particulateMatter10" : "Micrograms per cubic meter",
      "carbonMonoxide" : "Parts per million",
      "nitrogenDioxide" : "Parts per billion",
      "sulfurDioxide" : "Parts per billion",
      "ozone" : "Parts per million"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastDmaHourObj> 
     */
    open class func dmasDmaIdHoursGetWithRequestBuilder(dmaId: Int, fields: [String], unitScale: UnitScale_dmasDmaIdHoursGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastDmaHourObj> {
        var path = "/dmas/{dmaId}/hours"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastDmaHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdHoursTimestampGet: String { 
        case timestampinit = "timestampInit"
        case particulatematter1 = "particulateMatter1"
        case particulatematter2p5 = "particulateMatter2p5"
        case particulatematter10 = "particulateMatter10"
        case carbonmonoxide = "carbonMonoxide"
        case nitrogendioxide = "nitrogenDioxide"
        case sulfurdioxide = "sulfurDioxide"
        case ozone = "ozone"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdHoursTimestampGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     An hour of ECMWF Air Quality Forecast data for a DMA

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdHoursTimestampGet(dmaId: Int, timestamp: Date, fields: [String], unitScale: UnitScale_dmasDmaIdHoursTimestampGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastDmaHourObj?,_ error: Error?) -> Void)) {
        dmasDmaIdHoursTimestampGetWithRequestBuilder(dmaId: dmaId, timestamp: timestamp, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     An hour of ECMWF Air Quality Forecast data for a DMA
     - GET /dmas/{dmaId}/hours/{timestamp}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "forecast" : [ {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "particulateMatter1" : "Micrograms per cubic meter",
      "particulateMatter2p5" : "Micrograms per cubic meter",
      "particulateMatter10" : "Micrograms per cubic meter",
      "carbonMonoxide" : "Parts per million",
      "nitrogenDioxide" : "Parts per billion",
      "sulfurDioxide" : "Parts per billion",
      "ozone" : "Parts per million"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastDmaHourObj> 
     */
    open class func dmasDmaIdHoursTimestampGetWithRequestBuilder(dmaId: Int, timestamp: Date, fields: [String], unitScale: UnitScale_dmasDmaIdHoursTimestampGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastDmaHourObj> {
        var path = "/dmas/{dmaId}/hours/{timestamp}"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let timestampPreEscape = "\(timestamp)"
        let timestampPostEscape = timestampPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestamp}", with: timestampPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastDmaHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_dmasDmaIdHoursTimestampStarttimestampEndGet: String { 
        case timestampinit = "timestampInit"
        case particulatematter1 = "particulateMatter1"
        case particulatematter2p5 = "particulateMatter2p5"
        case particulatematter10 = "particulateMatter10"
        case carbonmonoxide = "carbonMonoxide"
        case nitrogendioxide = "nitrogenDioxide"
        case sulfurdioxide = "sulfurDioxide"
        case ozone = "ozone"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_dmasDmaIdHoursTimestampStarttimestampEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of hourly ECMWF Air Quality Forecast data for a DMA.

     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func dmasDmaIdHoursTimestampStarttimestampEndGet(dmaId: Int, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_dmasDmaIdHoursTimestampStarttimestampEndGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastDmaHourObj?,_ error: Error?) -> Void)) {
        dmasDmaIdHoursTimestampStarttimestampEndGetWithRequestBuilder(dmaId: dmaId, timestampStart: timestampStart, timestampEnd: timestampEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of hourly ECMWF Air Quality Forecast data for a DMA.
     - GET /dmas/{dmaId}/hours/{timestampStart},{timestampEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "dmaId" : 529,
    "dmaName" : "Louisville",
    "countryName" : "United States of America",
    "samplePoints" : [ {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    }, {
      "onpointId" : 10725864,
      "elevation" : 173.5,
      "distance" : 1536552,
      "grid" : "NORTH_AMERICA_GRID",
      "latitude" : 38.8552,
      "longitude" : -77.0513
    } ],
    "population" : 1584746
  },
  "forecast" : [ {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "particulateMatter1" : "Micrograms per cubic meter",
      "particulateMatter2p5" : "Micrograms per cubic meter",
      "particulateMatter10" : "Micrograms per cubic meter",
      "carbonMonoxide" : "Parts per million",
      "nitrogenDioxide" : "Parts per billion",
      "sulfurDioxide" : "Parts per billion",
      "ozone" : "Parts per million"
    }
  }
}}]
     - parameter dmaId: (path) A [Designated Market Area ID](https://developer.weathersourceapis.com/apis/supported-dmas/). 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastDmaHourObj> 
     */
    open class func dmasDmaIdHoursTimestampStarttimestampEndGetWithRequestBuilder(dmaId: Int, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_dmasDmaIdHoursTimestampStarttimestampEndGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastDmaHourObj> {
        var path = "/dmas/{dmaId}/hours/{timestampStart},{timestampEnd}"
        let dmaIdPreEscape = "\(dmaId)"
        let dmaIdPostEscape = dmaIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dmaId}", with: dmaIdPostEscape, options: .literal, range: nil)
        let timestampStartPreEscape = "\(timestampStart)"
        let timestampStartPostEscape = timestampStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampStart}", with: timestampStartPostEscape, options: .literal, range: nil)
        let timestampEndPreEscape = "\(timestampEnd)"
        let timestampEndPostEscape = timestampEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampEnd}", with: timestampEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastDmaHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
