//
// OnpointsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class OnpointsAPI {
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdDaysDateGet: String { 
        case timestampinit = "timestampInit"
        case airqualityindex = "airQualityIndex"
        case particulatematter1min = "particulateMatter1Min"
        case particulatematter1avg = "particulateMatter1Avg"
        case particulatematter1max = "particulateMatter1Max"
        case particulatematter2p5min = "particulateMatter2p5Min"
        case particulatematter2p5avg = "particulateMatter2p5Avg"
        case particulatematter2p5max = "particulateMatter2p5Max"
        case particulatematter10min = "particulateMatter10Min"
        case particulatematter10avg = "particulateMatter10Avg"
        case particulatematter10max = "particulateMatter10Max"
        case carbonmonoxidemin = "carbonMonoxideMin"
        case carbonmonoxideavg = "carbonMonoxideAvg"
        case carbonmonoxidemax = "carbonMonoxideMax"
        case nitrogendioxidemin = "nitrogenDioxideMin"
        case nitrogendioxideavg = "nitrogenDioxideAvg"
        case nitrogendioxidemax = "nitrogenDioxideMax"
        case sulfurdioxidemin = "sulfurDioxideMin"
        case sulfurdioxideavg = "sulfurDioxideAvg"
        case sulfurdioxidemax = "sulfurDioxideMax"
        case ozonemin = "ozoneMin"
        case ozoneavg = "ozoneAvg"
        case ozonemax = "ozoneMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdDaysDateGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A day of ECMWF Air Quality Forecast data for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdDaysDateGet(onpointId: Int, date: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysDateGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastOnpointDayObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdDaysDateGetWithRequestBuilder(onpointId: onpointId, date: date, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A day of ECMWF Air Quality Forecast data for an OnPoint™ point.
     - GET /onpoints/{onpointId}/days/{date}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "airQualityIndex" : "US EPA Air Quality Index",
      "particulateMatter1Min" : "Micrograms per cubic meter",
      "particulateMatter1Avg" : "Micrograms per cubic meter",
      "particulateMatter1Max" : "Micrograms per cubic meter",
      "particulateMatter2p5Min" : "Micrograms per cubic meter",
      "particulateMatter2p5Avg" : "Micrograms per cubic meter",
      "particulateMatter2p5Max" : "Micrograms per cubic meter",
      "particulateMatter10Min" : "Micrograms per cubic meter",
      "particulateMatter10Avg" : "Micrograms per cubic meter",
      "particulateMatter10Max" : "Micrograms per cubic meter",
      "carbonMonoxideMin" : "Parts per million",
      "carbonMonoxideAvg" : "Parts per million",
      "carbonMonoxideMax" : "Parts per million",
      "nitrogenDioxideMin" : "Parts per billion",
      "nitrogenDioxideAvg" : "Parts per billion",
      "nitrogenDioxideMax" : "Parts per billion",
      "sulfurDioxideMin" : "Parts per billion",
      "sulfurDioxideAvg" : "Parts per billion",
      "sulfurDioxideMax" : "Parts per billion",
      "ozoneMin" : "Parts per million",
      "ozoneAvg" : "Parts per million",
      "ozoneMax" : "Parts per million"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter date: (path) An date formatted as a RFC3339 date value. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastOnpointDayObj> 
     */
    open class func onpointsOnpointIdDaysDateGetWithRequestBuilder(onpointId: Int, date: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysDateGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastOnpointDayObj> {
        var path = "/onpoints/{onpointId}/days/{date}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let datePreEscape = "\(date)"
        let datePostEscape = datePreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{date}", with: datePostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastOnpointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdDaysDateStartdateEndGet: String { 
        case timestampinit = "timestampInit"
        case airqualityindex = "airQualityIndex"
        case particulatematter1min = "particulateMatter1Min"
        case particulatematter1avg = "particulateMatter1Avg"
        case particulatematter1max = "particulateMatter1Max"
        case particulatematter2p5min = "particulateMatter2p5Min"
        case particulatematter2p5avg = "particulateMatter2p5Avg"
        case particulatematter2p5max = "particulateMatter2p5Max"
        case particulatematter10min = "particulateMatter10Min"
        case particulatematter10avg = "particulateMatter10Avg"
        case particulatematter10max = "particulateMatter10Max"
        case carbonmonoxidemin = "carbonMonoxideMin"
        case carbonmonoxideavg = "carbonMonoxideAvg"
        case carbonmonoxidemax = "carbonMonoxideMax"
        case nitrogendioxidemin = "nitrogenDioxideMin"
        case nitrogendioxideavg = "nitrogenDioxideAvg"
        case nitrogendioxidemax = "nitrogenDioxideMax"
        case sulfurdioxidemin = "sulfurDioxideMin"
        case sulfurdioxideavg = "sulfurDioxideAvg"
        case sulfurdioxidemax = "sulfurDioxideMax"
        case ozonemin = "ozoneMin"
        case ozoneavg = "ozoneAvg"
        case ozonemax = "ozoneMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdDaysDateStartdateEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of daily ECMWF Air Quality Forecast data for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdDaysDateStartdateEndGet(onpointId: Int, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysDateStartdateEndGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastOnpointDayObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdDaysDateStartdateEndGetWithRequestBuilder(onpointId: onpointId, dateStart: dateStart, dateEnd: dateEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of daily ECMWF Air Quality Forecast data for an OnPoint™ point.
     - GET /onpoints/{onpointId}/days/{dateStart},{dateEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "airQualityIndex" : "US EPA Air Quality Index",
      "particulateMatter1Min" : "Micrograms per cubic meter",
      "particulateMatter1Avg" : "Micrograms per cubic meter",
      "particulateMatter1Max" : "Micrograms per cubic meter",
      "particulateMatter2p5Min" : "Micrograms per cubic meter",
      "particulateMatter2p5Avg" : "Micrograms per cubic meter",
      "particulateMatter2p5Max" : "Micrograms per cubic meter",
      "particulateMatter10Min" : "Micrograms per cubic meter",
      "particulateMatter10Avg" : "Micrograms per cubic meter",
      "particulateMatter10Max" : "Micrograms per cubic meter",
      "carbonMonoxideMin" : "Parts per million",
      "carbonMonoxideAvg" : "Parts per million",
      "carbonMonoxideMax" : "Parts per million",
      "nitrogenDioxideMin" : "Parts per billion",
      "nitrogenDioxideAvg" : "Parts per billion",
      "nitrogenDioxideMax" : "Parts per billion",
      "sulfurDioxideMin" : "Parts per billion",
      "sulfurDioxideAvg" : "Parts per billion",
      "sulfurDioxideMax" : "Parts per billion",
      "ozoneMin" : "Parts per million",
      "ozoneAvg" : "Parts per million",
      "ozoneMax" : "Parts per million"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter dateStart: (path) An date formatted as a RFC3339 date value that must occur temporally before dateEnd. 
     - parameter dateEnd: (path) An date formatted as a RFC3339 date value that must occur temporally after dateStart. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastOnpointDayObj> 
     */
    open class func onpointsOnpointIdDaysDateStartdateEndGetWithRequestBuilder(onpointId: Int, dateStart: Date, dateEnd: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysDateStartdateEndGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastOnpointDayObj> {
        var path = "/onpoints/{onpointId}/days/{dateStart},{dateEnd}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let dateStartPreEscape = "\(dateStart)"
        let dateStartPostEscape = dateStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateStart}", with: dateStartPostEscape, options: .literal, range: nil)
        let dateEndPreEscape = "\(dateEnd)"
        let dateEndPostEscape = dateEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{dateEnd}", with: dateEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastOnpointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdDaysGet: String { 
        case timestampinit = "timestampInit"
        case airqualityindex = "airQualityIndex"
        case particulatematter1min = "particulateMatter1Min"
        case particulatematter1avg = "particulateMatter1Avg"
        case particulatematter1max = "particulateMatter1Max"
        case particulatematter2p5min = "particulateMatter2p5Min"
        case particulatematter2p5avg = "particulateMatter2p5Avg"
        case particulatematter2p5max = "particulateMatter2p5Max"
        case particulatematter10min = "particulateMatter10Min"
        case particulatematter10avg = "particulateMatter10Avg"
        case particulatematter10max = "particulateMatter10Max"
        case carbonmonoxidemin = "carbonMonoxideMin"
        case carbonmonoxideavg = "carbonMonoxideAvg"
        case carbonmonoxidemax = "carbonMonoxideMax"
        case nitrogendioxidemin = "nitrogenDioxideMin"
        case nitrogendioxideavg = "nitrogenDioxideAvg"
        case nitrogendioxidemax = "nitrogenDioxideMax"
        case sulfurdioxidemin = "sulfurDioxideMin"
        case sulfurdioxideavg = "sulfurDioxideAvg"
        case sulfurdioxidemax = "sulfurDioxideMax"
        case ozonemin = "ozoneMin"
        case ozoneavg = "ozoneAvg"
        case ozonemax = "ozoneMax"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdDaysGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete daily ECMWF Air Quality Forecast for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdDaysGet(onpointId: Int, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastOnpointDayObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdDaysGetWithRequestBuilder(onpointId: onpointId, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete daily ECMWF Air Quality Forecast for an OnPoint™ point.
     - GET /onpoints/{onpointId}/days

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "dateRange" : {
    "dateStart" : "2019-12-20T00:00:00.000+00:00",
    "dateEnd" : "2019-12-20T00:00:00.000+00:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  }, {
    "date" : "2019-12-20T00:00:00.000+00:00",
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "nitrogenDioxideMax" : 100,
    "particulateMatter10Min" : 100,
    "particulateMatter10Avg" : 100,
    "ozoneMax" : 10,
    "particulateMatter1Min" : 100,
    "particulateMatter1Avg" : 100,
    "particulateMatter2p5Max" : 100,
    "carbonMonoxideMax" : 100,
    "nitrogenDioxideAvg" : 100,
    "nitrogenDioxideMin" : 100,
    "sulfurDioxideMin" : 100,
    "sulfurDioxideAvg" : 100,
    "ozoneMin" : 10,
    "ozoneAvg" : 10,
    "particulateMatter1Max" : 100,
    "particulateMatter2p5Min" : 100,
    "particulateMatter2p5Avg" : 100,
    "particulateMatter10Max" : 100,
    "carbonMonoxideAvg" : 100,
    "sulfurDioxideMax" : 100,
    "carbonMonoxideMin" : 100,
    "airQualityIndex" : 115
  } ],
  "fieldList" : {
    "fields" : {
      "date" : "Date as string: \"YYYY-MM-DD\"",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "airQualityIndex" : "US EPA Air Quality Index",
      "particulateMatter1Min" : "Micrograms per cubic meter",
      "particulateMatter1Avg" : "Micrograms per cubic meter",
      "particulateMatter1Max" : "Micrograms per cubic meter",
      "particulateMatter2p5Min" : "Micrograms per cubic meter",
      "particulateMatter2p5Avg" : "Micrograms per cubic meter",
      "particulateMatter2p5Max" : "Micrograms per cubic meter",
      "particulateMatter10Min" : "Micrograms per cubic meter",
      "particulateMatter10Avg" : "Micrograms per cubic meter",
      "particulateMatter10Max" : "Micrograms per cubic meter",
      "carbonMonoxideMin" : "Parts per million",
      "carbonMonoxideAvg" : "Parts per million",
      "carbonMonoxideMax" : "Parts per million",
      "nitrogenDioxideMin" : "Parts per billion",
      "nitrogenDioxideAvg" : "Parts per billion",
      "nitrogenDioxideMax" : "Parts per billion",
      "sulfurDioxideMin" : "Parts per billion",
      "sulfurDioxideAvg" : "Parts per billion",
      "sulfurDioxideMax" : "Parts per billion",
      "ozoneMin" : "Parts per million",
      "ozoneAvg" : "Parts per million",
      "ozoneMax" : "Parts per million"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter fields: (query) A comma separated list of field names to return. The date field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastOnpointDayObj> 
     */
    open class func onpointsOnpointIdDaysGetWithRequestBuilder(onpointId: Int, fields: [String], unitScale: UnitScale_onpointsOnpointIdDaysGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastOnpointDayObj> {
        var path = "/onpoints/{onpointId}/days"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastOnpointDayObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdHoursGet: String { 
        case timestampinit = "timestampInit"
        case particulatematter1 = "particulateMatter1"
        case particulatematter2p5 = "particulateMatter2p5"
        case particulatematter10 = "particulateMatter10"
        case carbonmonoxide = "carbonMonoxide"
        case nitrogendioxide = "nitrogenDioxide"
        case sulfurdioxide = "sulfurDioxide"
        case ozone = "ozone"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdHoursGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     The complete hourly ECMWF Air Quality Forecast for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdHoursGet(onpointId: Int, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastOnpointHourObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdHoursGetWithRequestBuilder(onpointId: onpointId, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     The complete hourly ECMWF Air Quality Forecast for an OnPoint™ point.
     - GET /onpoints/{onpointId}/hours

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "particulateMatter1" : "Micrograms per cubic meter",
      "particulateMatter2p5" : "Micrograms per cubic meter",
      "particulateMatter10" : "Micrograms per cubic meter",
      "carbonMonoxide" : "Parts per million",
      "nitrogenDioxide" : "Parts per billion",
      "sulfurDioxide" : "Parts per billion",
      "ozone" : "Parts per million"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastOnpointHourObj> 
     */
    open class func onpointsOnpointIdHoursGetWithRequestBuilder(onpointId: Int, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastOnpointHourObj> {
        var path = "/onpoints/{onpointId}/hours"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastOnpointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdHoursTimestampGet: String { 
        case timestampinit = "timestampInit"
        case particulatematter1 = "particulateMatter1"
        case particulatematter2p5 = "particulateMatter2p5"
        case particulatematter10 = "particulateMatter10"
        case carbonmonoxide = "carbonMonoxide"
        case nitrogendioxide = "nitrogenDioxide"
        case sulfurdioxide = "sulfurDioxide"
        case ozone = "ozone"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdHoursTimestampGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     An hour of ECMWF Air Quality Forecast data for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdHoursTimestampGet(onpointId: Int, timestamp: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursTimestampGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastOnpointHourObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdHoursTimestampGetWithRequestBuilder(onpointId: onpointId, timestamp: timestamp, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     An hour of ECMWF Air Quality Forecast data for an OnPoint™ point.
     - GET /onpoints/{onpointId}/hours/{timestamp}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "particulateMatter1" : "Micrograms per cubic meter",
      "particulateMatter2p5" : "Micrograms per cubic meter",
      "particulateMatter10" : "Micrograms per cubic meter",
      "carbonMonoxide" : "Parts per million",
      "nitrogenDioxide" : "Parts per billion",
      "sulfurDioxide" : "Parts per billion",
      "ozone" : "Parts per million"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter timestamp: (path) A timestamp formatted as an RFC3339 date-time value. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastOnpointHourObj> 
     */
    open class func onpointsOnpointIdHoursTimestampGetWithRequestBuilder(onpointId: Int, timestamp: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursTimestampGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastOnpointHourObj> {
        var path = "/onpoints/{onpointId}/hours/{timestamp}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let timestampPreEscape = "\(timestamp)"
        let timestampPostEscape = timestampPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestamp}", with: timestampPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastOnpointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter fields
     */
    public enum Fields_onpointsOnpointIdHoursTimestampStarttimestampEndGet: String { 
        case timestampinit = "timestampInit"
        case particulatematter1 = "particulateMatter1"
        case particulatematter2p5 = "particulateMatter2p5"
        case particulatematter10 = "particulateMatter10"
        case carbonmonoxide = "carbonMonoxide"
        case nitrogendioxide = "nitrogenDioxide"
        case sulfurdioxide = "sulfurDioxide"
        case ozone = "ozone"
        case all = "all"
    }

    /**
     * enum for parameter unitScale
     */
    public enum UnitScale_onpointsOnpointIdHoursTimestampStarttimestampEndGet: String { 
        case imperial = "IMPERIAL"
        case metric = "METRIC"
        case si = "SI"
    }

    /**
     A contiguous range of hourly ECMWF Air Quality Forecast data for an OnPoint™ point.

     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func onpointsOnpointIdHoursTimestampStarttimestampEndGet(onpointId: Int, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursTimestampStarttimestampEndGet? = nil, completion: @escaping ((_ data: EcmwfAirQualityForecastOnpointHourObj?,_ error: Error?) -> Void)) {
        onpointsOnpointIdHoursTimestampStarttimestampEndGetWithRequestBuilder(onpointId: onpointId, timestampStart: timestampStart, timestampEnd: timestampEnd, fields: fields, unitScale: unitScale).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     A contiguous range of hourly ECMWF Air Quality Forecast data for an OnPoint™ point.
     - GET /onpoints/{onpointId}/hours/{timestampStart},{timestampEnd}

     - API Key:
       - type: apiKey X-API-KEY 
       - name: ApiKeyAuth
     - examples: [{contentType=application/json, example={
  "timestampRange" : {
    "timestampEnd" : "2019-12-20T23:00:00-05:00",
    "timestampStart" : "2019-12-20T23:00:00-05:00"
  },
  "location" : {
    "onpointId" : 10725864,
    "elevation" : 173.5,
    "timezone" : "America/New_York",
    "countryCode" : "US",
    "grid" : "NORTH_AMERICA_GRID",
    "latitude" : 38.8552,
    "countryName" : "United States of America",
    "subdivName" : "Virginia",
    "subdivCode" : "US-VA",
    "longitude" : -77.0513
  },
  "forecast" : [ {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  }, {
    "particulateMatter2p5" : 100,
    "timestampInit" : "2019-12-20T23:00:00-05:00",
    "sulfurDioxide" : 100,
    "particulateMatter1" : 100,
    "carbonMonoxide" : 100,
    "nitrogenDioxide" : 100,
    "particulateMatter10" : 100,
    "ozone" : 10,
    "timestamp" : "2019-12-20T23:00:00-05:00"
  } ],
  "fieldList" : {
    "fields" : {
      "timestamp" : "Timestamp as string: RFC 3339",
      "timestampInit" : "Timestamp as string: RFC 3339",
      "particulateMatter1" : "Micrograms per cubic meter",
      "particulateMatter2p5" : "Micrograms per cubic meter",
      "particulateMatter10" : "Micrograms per cubic meter",
      "carbonMonoxide" : "Parts per million",
      "nitrogenDioxide" : "Parts per billion",
      "sulfurDioxide" : "Parts per billion",
      "ozone" : "Parts per million"
    }
  }
}}]
     - parameter onpointId: (path) An OnPoint™ ID. 
     - parameter timestampStart: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally before timestampEnd. The UTC offset is required. 
     - parameter timestampEnd: (path) A timestamp formatted as an RFC3339 date-time value that must occur temporally after timestampStart. The UTC offset is required. 
     - parameter fields: (query) A comma separated list of field names to return. The timestamp field is always returned.  **Limiting the query to needed fields will improve the query response time.**  In addition to individual field names, following convenience field groups are also supported: * all *(all fields)*  
     - parameter unitScale: (query) The unit scale for returned values.&lt;br&gt; (optional, default to IMPERIAL)

     - returns: RequestBuilder<EcmwfAirQualityForecastOnpointHourObj> 
     */
    open class func onpointsOnpointIdHoursTimestampStarttimestampEndGetWithRequestBuilder(onpointId: Int, timestampStart: Date, timestampEnd: Date, fields: [String], unitScale: UnitScale_onpointsOnpointIdHoursTimestampStarttimestampEndGet? = nil) -> RequestBuilder<EcmwfAirQualityForecastOnpointHourObj> {
        var path = "/onpoints/{onpointId}/hours/{timestampStart},{timestampEnd}"
        let onpointIdPreEscape = "\(onpointId)"
        let onpointIdPostEscape = onpointIdPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{onpointId}", with: onpointIdPostEscape, options: .literal, range: nil)
        let timestampStartPreEscape = "\(timestampStart)"
        let timestampStartPostEscape = timestampStartPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampStart}", with: timestampStartPostEscape, options: .literal, range: nil)
        let timestampEndPreEscape = "\(timestampEnd)"
        let timestampEndPostEscape = timestampEndPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{timestampEnd}", with: timestampEndPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "fields": fields, 
                        "unitScale": unitScale?.rawValue
        ])


        let requestBuilder: RequestBuilder<EcmwfAirQualityForecastOnpointHourObj>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
}
